<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 3.2//EN">

<HTML>

<HEAD>
<TITLE>Projets de Maitrise</TITLE>
<style>
em {color:#802000; font-weight:bold;}
.bi {color:#005000; font-weight:bold; font-size:18pt; 
   font-family:Times,serif;}
.bl {color: #a00000}
</style>

</HEAD>

<BODY BACKGROUND="bkgblue.gif">

<!--
<BODY BACKGROUND="bkgblue.gif" BGCOLOR="#C0E0E0" TEXT="#000000" LINK="#604000" VLINK="#882060" ALINK="#ff0000">
-->


<CENTER><H1><FONT COLOR=#d20000>
Projets de Maîtrise 1999/<a href="javascript:alert('Ah non ! Bug2000...!')">00</a>
</FONT></H1>
</CENTER>
<P>
<b>

<blink><font color=#006000>Obsolète</font></blink>
<p>


<font color=#006000>(Les projets obsolètes, de l'année dernière
  <a href="maitr98.html">se trouvent ici.</a></font>
<p>

J'offre en principe 4 sujets, ce qui est un peu trop pour ma disponibilité, mais
ainsi vous aurez plus de choix.

<P>
<P>
<HR WIDTH="95%" ALIGN=CENTER>
<P>

Les projets officiels sont :
<OL>
<LI> <A HREF="#compal">Composition musicale algorithmique</A>
<LI> <A HREF="#songen">Génération de sons et effets sonores</A>
<LI> <A HREF="#pavage">Pavages de Escher</A>
<LI> <A HREF="#coquil">Modélisation de coquilles</A>
</OL>
<P>

Donc, les deux premiers projets sont consacrés à l'informatique auditive, comme je vous
ai promis par e-mail. Je répète : vous n'êtes pas obligés de connaître la théorie
musicale, ou la physique de création de sons, les sujets ne sont pas très lourds. Mais
il faut avoir un certain engagement personnel, et - surtout - maîtriser le rendu
sonore  standard sur la plate-forme que vous allez utiliser (Linux? Windows? Solaris?)
Elle doit être capable de jouer les fichiers .mid et les fichiers type .wav|.au .
<p>

Les deux autres c'est de l'imagerie : 2D dans le premier cas, 3D dans le second. Dans
les deux cas c'est de la géométrie un peu formelle. Symétries, répétition d'un
motif, récursivité/itérations appliquées à la génération des objets géométriques.

<p>
<span class="bi">
Attention : <br>
J'ai eu trop de "clients", retenus dans l'ordre d'arrivée :
<ul>
<li> Projet 1 : musique algorithmique :  NÉANT
<li> Projet 2 : génération des sons
<ul>
 <li> <u><span class=bl>Petit Christophe, Gigan Davy</span></u>
</ul>

<li> Projet 3 : pavages
<ul>
 <li> <u><span class=bl>Guerlus Thierry, Groult Rémi</span></u>
</ul>

<li> Projet 4 : coquilles
<ul>
 <li> <u><span class=bl>Rattier Damien, Porcq Thimothe</span></u>
</ul>
<p>
(Je confirme l'abandon volontaire de la part du binôme Houssin/Lelong)
<p>

Si le projet 1 reste toujours vacant, je peux inventer une autre chose pour remplir mon
quota. Contactez-moi le plus tôt possible, si vous êtes intéressés, et surtout si
vous avez quelque chose à proposer vous même.
</ul>

</span>

<p>

<p>
<HR WIDTH="70%" ALIGN=CENTER size=6 noshade>
<P>


<A name="compal">
<H2>1. Paquetage de composition algorithmique de musique 
<img src="cart0002.gif" align=absmiddle></H2>

<!--
<P>
<font color="#F00000">
(<img src="../../icons/starroll.gif" align=abscenter> &nbsp; Ce projet est déjà pris par.)
</font>
<p>
-->

<OL>
<LI> <H3>Énoncé et cahier des charges</H3>
   Le langage fonctionnel Haskell est distribué avec une jolie librairie
   musicale conçue par Paul Hudak : "Haskore", qui permet de représenter la musique,
   les notes, phrases, etc. de manière très élégante, et de combiner les 
   morceaux musicaux. Ce n'est qu'une librairie, et non pas un "compositeur".
  <p>

   Les algorithmes de composition algorithmique existent aussi, et reposent
   sur les propriétés spectrales des suites de notes (musique fractale,
   bruit 1/f, etc.). On trouve quelques algorithmes codés en KeyKit de 
   Tim Thompson - un paquetage graphique, programmable dans un langage de 
   relativement bas niveau.
   <p>

   Le projet consiste à récupérer quelques techniques de composition 
   algorithmique, et de les coder en Haskore. Générer quelques fichiers MIDI 
   et impressionner l'auditoire...


<P>
<HR WIDTH="75%" ALIGN=CENTER size=4 noshade>
<P>

<LI> <h3>Commentaires</h3>
Haskore peut être maîtrisé en quelques heures, il n'y a rien de compliqué là-dedans,
mais <em>il faut connaître ou apprendre Haskell</em>. Cela tombe bien, car vous
êtes tous motivés à apprendre ce langage pour d'autres raisons, n'est-ce pas?<p>

Avec le KeyKit, et autres détails concernant les algorithmes de composition, la partie
la plus longue de ce projet est l'apprentissage, et non pas le codage. Vous n'aurez
pas à apprendre le format MIDI (sauf si vous voulez). Les paquetages utilisés 
génèrent ces fichiers sans problèmes.

<P>
<HR WIDTH="75%" ALIGN=CENTER size=4 noshade>
<P>

<LI> <h3>Références</h3>
<ul>
<li> <a href="http://newb6.u-strasbg.fr/~yvesgro/musique.html" target=_top>Musique algorithmique, approche linguistique</a>Un article d'Yves Grosdidier (Strasbourg).

<li> <a href="http://music.dartmouth.edu/~wowem/hardware/algorithmdefinition.html" target=_top>Un autre article sur la composition algorithmique</a>.

<li> <a href="http://www.ircam.fr/index1.html" target=_top>Le serveur de IRCAM</a>. Référence essentielle, même si le contenu est un peu trop riche pour les profanes.

<li> <a href="http://haskell.org/haskore/" tqrget=_top>Haskore</a>

<li> <a href="http://209.233.20.72/keykit/" target= _top>KeyKit</a>. Suivez les liens
sur "Tune Toys". C'est ici que Tim Thompson a mis un nombre de réalisations concrètes
de musique algorithmique, tout décrit en langage-source de KeyKit (tout disponible
gratuitement, bien sûr).
<li> <a href="http://listen.to/algo-comp" target=_top>Une courte collection de liens sur
la composition algorithmique</a>. Regardez p. ex. la documentation du paquetage PPP (rien
à voir avec le Point-to-Point ...).
<li> <a href="http://www-ks.rus.uni-stuttgart.de/people/schulz/fmusic/" target=_top>Musique fractale</a>, une collection de liens - soft et articles.

<li> <a href="http://www.geocities.com/Vienna/9349/" target=_top>Écoutez les mathématiques</a> - une page de Daniel Cummerow qui a utilisé le nombre PI, ou les
nombres premiers pour piloter un générateur algorithmique (brièvement défini). Les
résultats sont très jolis ! (Cherchez un plugin MIDI pour votre Netscape, p. ex.
Crescendo pour Windows, ou UMP sous Unix, et <a href="pi.mid">écoutez</a> ça,
ou <a href="piom.mid">autres</a> <a href="primesb3.mid">choses</a>.


<li> <a href="http://www.ece.umd.edu/~blj/algorithmic_composition/algorithmicmodel.html" target=_top>Un article sur la composition algorithmique</a> par Bruce L. Jacob.

<li> <a href="http://ccrma-www.stanford.edu/CCRMA/Software/clm/clm.html" target=_top>Common Lisp Music</a>, une référence qui nous pourra être utile un jour.

<li> <a href="http://209.233.20.72/plum/cgi/showlist.cgi?sort=name" target=_top>PLUM - 
Programming Languages Used for Music</a> - une liste très complète, compilée par Tim
Thompson.

<li> <a href="http://hyperion.advanced.org/15413/" target=_top>Music Notes</a> - un peu de
théorie, de description des instruments, etc. Pour ceux intéressés vraiment par la
musique, mais débutants complets.

<li> <a href="http://mitpress.mit.edu/e-journals/Computer-Music-Journal/CMJ.html" target=_top>Computer Music Journal</a> - une autre référence pour les vrais mordus.

<li> <a href="http://home.earthlink.net/~mma/gminfo.htm" target=_top>Informations générales sur MIDI</a>

<li> <a href="http://www.borg.com/~jglatt/" target=_top>Et encore presque tout sur MIDI</a>.

<li> <a href="http://www.harmonycentral.com//" target=_top>Harmony Central</a>, un site 
sur MIDI, musique et presque tout.

</ul>
<p>
Si cela ne vous suffit pas, je vous fournirai une liste 100 fois plus longue, mais 
soyons rationnels...

</OL>

<P>
<HR WIDTH="95%" ALIGN=CENTER size=10 noshade>
<P>
<P>

<!-- ++++++++++++++++++++++++++++++++++++++++++++++++++++++
     ++++++++++++++++++++++++++++++++++++++++++++++++++++++ -->

<A NAME="songen"></A>
<H2>2. Synthèse algorithmique des "instruments" (motifs sonores). 
<img src="cart0028.gif" align=absmiddle></H2><P>
<P>

<!--
<font color="#F00000">
(<img src="../../icons/starroll.gif" align=abscenter> &nbsp; Ce projet est déjà pris par .)
</font>
<p>
-->

<OL>

<LI> <H3>Le projet</H3>

  Ce projet concerne les techniques de génération des sons, non pas des notes  
  musicales. Il existe un bon nombre de langages et paquetages de création
  des motifs sonores (p. ex. fichiers au format .wav, ou .au, ou .snd) avec 
  la composition spectrale et l'envelope désirées. Le plus populaire système
  est le CSound, très universel, mais programmable dans un langage style
  assembleur.
  Le projet consiste à prendre quelques techniques de génération : addition
  de patterns ondulatoires (composition de fréquences), techniques 
  soustractives : filtrage, etc., - <br>

  - peut-être aussi quelques techniques de <i>modélisation physique</i> (p. ex.
  d'une corde vibrante), et créer quelques terribles sons.<p>

  Accessoirement nous pourrons analyser et implanter quelques techniques de génération 
  d'effets spéciaux : echo, reverberation, transposition, tremolo, vibrato, etc., 
  et de coder 
  cela en Java, de construire une hiérarchie de classes et méthodes qui  
  représenteront des objets sonores et leur combinaisons. Si possible, prévoir 
  une interface graphique sympa.

<P>
<HR WIDTH="75%" ALIGN=CENTER size=4 noshade>
<P>

<LI> <H3>Commentaires</H3>

Ce projet est une expédition exploratoire d'un domaine intéressant, mais pas
tellement populaire <b>ici</b>. Si vous avez peur d'être obligés d'apprendre les
équations de physique qui décrivent les resonances dans un saxophone, etc. - ne
craignez rien (en fait, personne ne sait vraiment tout sur les resonances dans
un saxophone ou même une trompette...)<p>

Le nombre d'algorithmes publiés est important, seulement leur recherche n'est
pas toujours facile, car les détails sont éparpillés. Mais nous avons l'Internet
et la bibliothèque d'IRCAM.


<P>
<HR WIDTH="75%" ALIGN=CENTER size=4 noshade>
<P>

<LI> <h3>Références</h3>

<P>

<ul>
<li> <a href="http://www.leeds.ac.uk/music/Man/c_front.html" target=_top>Tout sur CSound</a>. Downloads, ressources, matériaux pédagogiques.

<li> <a href="http://www-ks.rus.uni-stuttgart.de/people/schulz/fmusic/" target=_top>Le projet "Fractal Music"</a>.

<li> <a href="http://ccrma-www.stanford.edu/CCRMA/Software/clm/clm.html" target=_top>Common Lisp Music</a>. Ce paquetage génère et traite les partitions musicales, mais il possède aussi une couche "basse": musique vue de la perspective de traitement des signaux.

<li> <a href="http://www.softsynth.com/musiclinks.html" target=_top>Computer Music Links</a>. (Pour ne pas oublier). Ceci est une "méta-page", avec des dizaines de liens. Elle était très
utile pour moi.

<li> <a href="http://www.cs.princeton.edu/~prc/NewWork.html" target=_top>Une page de Perry Cook</a>. Concrètement, regardez son atelier de synthèse STK, et l'interface SKINI.

<li> <a href="http://www.syntrillium.com/cooledit/cool96.htm" target=_top>Cool Edit 96</a>. Pour les usagers de Windows : ce produit - commercial, mais dont la version gratuite est
raisonablement utilisable - peut vous inspirer, répondre aux questions : quelles sont les
fonctionnalités demandés d'un paquetage de traitement des sons.

<li> <a href="http://markwhite.com/vsp/" target=_top>Virtual Synth Page</a>. Une initiative de ramassege des liens sur les techniques de synthèse et traitement des sons, modulation, échantillonnage, etc.

<li> <a href="http://karbosguide.com/module7d1.htm" target=_top>A Guide to digital music</a>. (Vous pouvez passer par <a href="http://karbosguide.com" target=_top>http://karbosguide.com</a>, et suivre les liens. Pour l'apprentissage de l'essentiel.

<li> <a href="http://www.hitsquad.com/smm/" target=_top>Shareware Music Machine</a>. Liens sur les plugins, analyseurs des spectres, samplers (échantillonneurs), synthétiseurs, etc.

<li> <a href="http://sound.media.mit.edu/people/eds/mpeg4/FCD/" target=_top>MPEG-4 Structured Audio</a>. 700K de texte, avec la terminologie, formats, et autres choses. Ne lisez pas, une journée complète de travail. Mais ce sera utile de l'avoir sous la main.<p>
<em>Montez d'un crin (effacez FCD de l'URL), et cherchez les information sur SAOL et le
paquetage saolc. Celui-là peut nous servir directement. </em>

<li> <a href="http://sound.media.mit.edu/~mkc/netsound.html" target=_top>Le projet NetSound</a>.

<li> <a href="http://www.synoptic.net/prodtext.htm" target=_top>Virtual Waves, Probe, etc.</a>.
Quelques réalisations commerciales (chargeables avec limitations).

<li> <a href="http://alpha.science.unitn.it/~oss/audioform/AudioFormats.html" target=_top>Description de plusieurs formats audio</a>.

<li> <a href="http://www.compsoc.man.ac.uk/~maniac/resource_web/" target=_top>Une page de Neil Isherwood</a>. Informations <em>très utiles</em> sur les techniques de synthèse et effets
spéciaux. Suivez les liens sur Harmony Central. (En fait, je soupçonne que ces textes
sont incomplets ; cherchez plutôt directement
<a href="http://www.harmonycentral.com/" target=_top>à la source</a>).

<li> <a href="http://www.hitsquad.com/smm/freeware/linux/" target=_top>Une collection de ressources audio pour Linux</a>. Impressionante.


</ul>
<p>

J'arrête ici seulement pour des raisons humanitaires (vos pauvres têtes, et mes pauvres doigts...)
<p>

</OL>
<P>
<P>
<HR WIDTH="95%" ALIGN=CENTER size=10 noshade>
<P>



<!-- ++++++++++++++++++++++++++++++++++++++++++++++++++++++
     ++++++++++++++++++++++++++++++++++++++++++++++++++++++ -->

<A NAME="pavage"></A>
<H2>3. Génération de pavages dans le style de M. Escher. 
<img src="roset.gif" align=absmiddle></H2><P>
<P>

<!--
<font color="#F00000">
(<img src="../../icons/starroll.gif" align=abscenter> &nbsp; Ce projet est déjà pris par .)
</font>
<p>
-->

<OL>

<LI> <H3>Le projet</H3>
  Tout le monde connait les tesselations - pavages - remplissages du plan par 
  des motifs géométriques qui se répètent avec des variantes, crées par 
  Maurits Cornelis Escher (1898-1972).<p>

  Le projet consiste à construire un générateur de pavages. Le motif fourni 
  par le programmeur sera répété, subira des rotations et réflexions selon
  quelques règles de symétrie, etc. <p>
  Le programme doit générer les pavages "infinis", euclidéens, mais aussi des
  "rosettes", basées sur la distortion stéréographique du plan, où la taille
  des objets éloignés du centre diminue, et "l'infini" se trouve à une distance
  finie du centre, comme sur le dessin ci-dessus.<p>
  Langage de programmation : arbitraire, à négocier. On n'a pas besoin d'une puissance
  calculatoire exorbitante, alors la facilité d'interfaçage, et la gestion et
  transformation des objets complexes sont plus importants. Java? ObjectiveCAML? Tcl/Tk
  ou Python? Choisissez...

<P>
<HR WIDTH="75%" ALIGN=CENTER size=4 noshade>
<P>

<LI> <H3>Commentaires</H3>

Il faudra apprendre un peu de géométrie planaire, et concrètement un peu sur les symétries. Le choix de la symétrie est (presque) la première décision à prendre. Ensuite un dessin simple,
un segment de ligne, ou un polygône sera répliqué avec des translations, rotations et
réflexions en fonction de cette symétrie.<p>
Le programme sauvegardera le dessin (fait intéractivement), et pourra passer à la
"géométrie non-euclidéenne" pour faire des rosettes. (Les transformations sont simples,
projection stéréographique, inversion, etc.).<p>

(<i>Les dessins de M. Escher sont la propriété de Cordon Art BV., Pays Bas. Cette compagnie
a provoqué la fermeture de plusieurs sites Web avec les copies des tableaux d'Escher, mais
je vois récemment une renaissance de ces sites, peut-être la politique de Cordon a 
changé, ou, sachant qu'ils ne peuvent pas se battre contre tout le monde, ils restent
plus calmes... En tout cas, soyez vigilants, UniCaen n'a pas d'argent pour payer les amendes.</i>)

<P>
<HR WIDTH="75%" ALIGN=CENTER size=4 noshade>
<P>

<LI> <h3>Références</h3>

<P>

<ul>
<li> <a href="http://www.WorldOfEscher.com/" target=_top>The World of Escher</a>.

<li> <a href="http://www.tabletoptelephone.com/~hopspage/" target=_top>Les pages de David Hollister</a>. <em>Essentiel.</em> Il a travaillé sur les pavages et autres jeux
géométriques d'Escher avec un grand talent et compétence. (Et une folie créatrice
impressionante). Il y a des liens sur d'autres pages sur Escher aussi...

<li> <a href="http://dspace.dial.pipex.com/crompton/Home.shtml" target=_top>... en particulier, les pages de Andrew Crompton</a>. Obligatoires.

<li> <a href="http://www.djmurphy.demon.co.uk/escher.htm" target=_top>Escher, collection</a>.

<li> <a href="http://www.unm.edu/~cwootton/escher.html" target=_top>Une autre galerie</a>.

<li> <a href="http://www.geom.umn.edu/apps/gallery.html" target=_top>University of Minnesota Geometry Center: Interactive on-line geometry</a>. Vérifiez les paquetages, notamment Kali,
et QuasiTiler.

<li> <a href="http://www.znet.com/~wchow/javagraf.htm" target=_top>Informations sur pavages, applets Java</a>.

<li> <a href="http://home6.inet.tele.dk/bergmann/10galleri/idx10.htm#Galleriet" target=_top>Pavages, JavaSketchpad</a>. (Ceci peut vous être très utile).

<li> <a href="http://www.geocities.com/williamwchow/escher/escher.htm" target=_top>Une autre page sur pavages</a>, avec beaucoup de références.

<li> <a href="http://ls7-www.cs.uni-dortmund.de/~kohnhors/kosima/index.htm" target=_top>Kosima, un programme pour faire les pavages (aussi animés)</a>.


</ul>
<p>



</OL>
<P>
<P>

<HR WIDTH="95%" ALIGN=CENTER size=10 noshade>
<P>



<!-- ++++++++++++++++++++++++++++++++++++++++++++++++++++++
     ++++++++++++++++++++++++++++++++++++++++++++++++++++++ -->

<A NAME="coquil"></A>
<H2>4. Génération des coquilles d'escargots et autres gastropodes. 
<img src="amm.gif" align=absmiddle></H2><P>
<P>

<!--
<font color="#F00000">
(<img src="../../icons/starroll.gif" align=abscenter> &nbsp; Ce projet est déjà pris par .)
</font>
<p>
-->

<OL>

<LI> <H3>Le projet</H3>
  Les formes des coquillages sont normalement très régulières, et les 
  algorithmes récursifs ou itératifs de leur génération sont connus. 
  Le nombre de paramètres n'est pas très grand. Il existe même un paquetage :  
  "Shellylib" qui génère une grande variété de coquilles, mais c'est un
  produit commercial (shareware). 
  (Demo chargeable, sous Windows, pour l'originalité...)<p>

  Le projet consiste à faire un petit modeleur capable de générer de telles
  formes, et de les visualiser de manière simpliste, p. ex. en utilisant
  OpenGL. Le paquetage doit pouvoir générer un fichier POV ou RIB, permettant
  ensuite la création d'une joli image par un lanceur de rayons populaire,
  POVRay, ou BMRT. (Les autres ne sont pas exclus.)



<P>
<HR WIDTH="75%" ALIGN=CENTER size=4 noshade>
<P>

<LI> <H3>Commentaires</H3>

Une coquille est un objet 3D, mais naturellement c'est une surface. On essaira de les
générer comme des surfaces paramétriques, où le vecteur <b>x</b>=(x,y,z) est une fonction
de deux paramètres qui définissent le repère local : <b>x</b> = <b>x</b>(s,t). La technique
classique (pas unique) est de prendre une courbe, et de la déplacer - translations, rotations, modifications d'échelle, "vibrations internes", etc.  - tout ceci produit des surfaces parfois très complexes.<p>

Quand la géometrie est accepté, le programme peut générer un fichier POV ou RIB avec des
textures, pour donner "un peu de vie" à l'objet.


<P>
<HR WIDTH="75%" ALIGN=CENTER size=4 noshade>
<P>

<LI> <h3>Références</h3>

<P>
Je dois avoir (quelque part...) l'article de Fowler/Meinhardt/Prusinkiewicz 
présenté à SIGGRAPH'92 sur la modélisation de ces bestioles. En cas de besoin je
le trouverai.

<p>
Si vous trouvez : "The Algorithmic Beauty of Shells"  (H. Meinhardt. Springer-Verlag), vous aurez tout...

<p>

<ul>
<li> <a href="http://www.shelly.core.de/" target=_top>ShellyLib de Randolph Schutz</a>. (Si vous l'achetez, vous aurez des sources, et le projet sera plus facile... (Oui, c'est une plaisanterie)).

<li> <a href="http://www.tc.cornell.edu/Visualization/contrib/cs490-96to97/wang/re2.html" target=_top>Un article de Ngai Ming Wang sur la modélisation des coquilles avec OpenGL</a>.

<li> <a href="http://www.informatik.uni-bremen.de/~ingo/Publications/tos/tos.html" target=_top>Article sur les textures des coquillages</a>. Cet article de Ingo Hunsinger est défectueux.

<li> <a href="http://www.sigmaxi.org/amsci/issues/comsci95/compsci95-05.html" target=_top>Un article de Brian Hayes sur les textures</a>.

<li> <a href="http://www.ma.iup.edu/MathDept/Projects/CalcDEMma/SeaShellCode.html" target=_top>Codage de coquilles en Mathematica</a>. (Pas très intéressant).

<li> <a href="http://www.cs.hku.hk/~tlchung/seashell.html" target=_top>Le programme de Kelvin Chung</a>.

<li> <a href="http://www.dcs.gla.ac.uk/~tony/ss/default.html" target=_top>Une page de Tony Printezis</a>. (Un autre programme de modélisation).

<li> <a href="http://habanero.cb.uga.edu/GSC/images.html" target=_top>Une méta-page avec les liens sur images</a>.

<li> <a href="http://www.saveurs.sympatico.ca/ency_7/jacouron.htm" target=_top>Un lien vital, ne le ratez pas</a>.

</ul>
<p>
Cela à part, si vous voulez voir quelques milliers d'exemples, lancez AltaVista
avec le mot-clé "seashells", et vous pouvez passer quelques jours dessus. Commencez
<a href="http://www.seashells.org/" target=_top>ici</a>.


</OL>
<P>
<P>
<HR WIDTH="95%" ALIGN=CENTER size=10 noshade>
<P>



<P>


</OL>
<P>
<P>


<P>
<HR WIDTH="95%" ALIGN=CENTER>
<P>

Des questions? Décision prise? 
Suggestions d'autres sujets? Propositions d'un emploi fictif bien
rémunéré? Alors <A HREF="mailto:karczma@info.unicaen.fr">mailto:karczma@info.unicaen.fr</A>
<P>


</b>







</BODY>

</HTML>
